/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.stimmeingabe.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="ERGEBNIS_GUELTIGER_EINGANG.ByErgebnisAndGebiet",
     query="DELETE FROM ErgebnisGueltigerEingang ege WHERE ege.ergebnis = ?1 AND EXISTS(SELECT ee FROM Ergebniseingang ee WHERE ege.ergebniseingang = ee AND ee.wahldurchfuehrungsgebiet IN (?2))",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNIS_GUELTIGER_EINGANG.CountGueltigeEingaengeByErgebnis",
     query="SELECT COUNT(o) FROM ErgebnisGueltigerEingang o WHERE o.ergebnis = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNIS_GUELTIGER_EINGANG.Ergebnis",
     query="SELECT o FROM ErgebnisGueltigerEingang o WHERE o.ergebnis = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNIS_GUELTIGER_EINGANG.Ergebniseingang",
     query="SELECT o FROM ErgebnisGueltigerEingang o WHERE o.ergebniseingang = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNIS_GUELTIGER_EINGANG.WahlAndErgebniseingangEingabeHashCode",
     query="SELECT obj FROM ErgebnisGueltigerEingang obj WHERE obj.ergebnis.wahl =?1 AND UPPER(obj.ergebniseingang.eingabeHashCode) LIKE UPPER(?2)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNIS_GUELTIGER_EINGANG.WahlAndErgebniseingangsartGebietnummerGebietsartname",
     query="SELECT o FROM ErgebnisGueltigerEingang o WHERE o.ergebnis.wahl =?1 AND o.ergebniseingang.ergebniseingangsart=?2 AND o.ergebniseingang.wahldurchfuehrungsgebiet.nummer = ?3 AND o.ergebniseingang.wahldurchfuehrungsgebiet.gebietsart.name = ?4",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNIS_GUELTIGER_EINGANG.WahlAndErgebniseingangsart",
     query="SELECT o FROM ErgebnisGueltigerEingang o WHERE o.ergebnis.wahl =?1 AND o.ergebniseingang.ergebniseingangsart=?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "ERGEBNIS_GUELTIGER_EINGANG")
// @javax.persistence.IdClass(ErgebnisGueltigerEingangPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class ErgebnisGueltigerEingang
extends AbstractErgebnisGueltigerEingang
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected ErgebnisGueltigerEingang() {
    super();
  }
    public ErgebnisGueltigerEingang(de.ivu.elect.jee.entity.customdata.CustomData customData){
                      if (customData != null && de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE != customData) {
          customData.setTechnicalEntity(this);
          customDataStorage = new de.ivu.elect.business.customdata.entity.CustomDataStorage(customData);
        }
            }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public ErgebnisGueltigerEingang(ErgebnisGueltigerEingang original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "ergebnis_gueltiger_eingang_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "ErgebnisGueltigerEingang")
    @javax.persistence.TableGenerator(name = "ErgebnisGueltigerEingang", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "ErgebnisGueltigerEingang", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient ErgebnisGueltigerEingangPK pkCache;

  @Override
  public ErgebnisGueltigerEingangPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new ErgebnisGueltigerEingangPK(getId());
    }

    return pkCache;
  }

  public static <E extends ErgebnisGueltigerEingang> java.util.Map<ErgebnisGueltigerEingangPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<ErgebnisGueltigerEingangPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends ErgebnisGueltigerEingang> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {

      hasChangedCustomDataStorage = false;
        hasChangedErgebniseingang = false;
        hasChangedErgebnis = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */


/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu CustomDataStorage
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "CUSTOM_DATA_STORAGE_ID", referencedColumnName="CUSTOM_DATA_STORAGE_ID"))
  protected de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage;

  /**
   * 
   */
  @Override
  public void setCustomDataStorage(@javax.annotation.Nullable  de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.customDataStorage
    , customDataStorage);

    attributeChanged |= thisAttributChanged;

    hasChangedCustomDataStorage |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("customDataStorage");
    }

    this.customDataStorage = customDataStorage;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.customdata.entity.CustomDataStorage getCustomDataStorage(){
    return this.customDataStorage;
  }

  @javax.persistence.Transient
  protected boolean hasChangedCustomDataStorage = false;

  public boolean hasChangedCustomDataStorage(){
    return hasChangedCustomDataStorage;
  }

  /**
   * Beziehung (unidirektional) zu Ergebniseingang
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "ERGEBNISEINGANG_ID", referencedColumnName="ERGEBNISEINGANG_ID"))
  protected de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang ergebniseingang;

  /**
   * 
   */
  @Override
  public void setErgebniseingang( de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang ergebniseingang){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebniseingang
    , ergebniseingang);

    attributeChanged |= thisAttributChanged;

    hasChangedErgebniseingang |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("ergebniseingang");
    }

    this.ergebniseingang = ergebniseingang;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang getErgebniseingang(){
    return this.ergebniseingang;
  }

  @javax.persistence.Transient
  protected boolean hasChangedErgebniseingang = false;

  public boolean hasChangedErgebniseingang(){
    return hasChangedErgebniseingang;
  }

  /**
   * Beziehung (unidirektional) zu Ergebnis
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "ERGEBNIS_ID", referencedColumnName="ERGEBNIS_ID"))
  protected de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis;

  /**
   * 
   */
  @Override
  public void setErgebnis( de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebnis
    , ergebnis);

    attributeChanged |= thisAttributChanged;

    hasChangedErgebnis |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("ergebnis");
    }

    this.ergebnis = ergebnis;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.ergebnis.entity.Ergebnis getErgebnis(){
    return this.ergebnis;
  }

  @javax.persistence.Transient
  protected boolean hasChangedErgebnis = false;

  public boolean hasChangedErgebnis(){
    return hasChangedErgebnis;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("ErgebnisGueltigerEingang:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(ErgebnisGueltigerEingang other){
        
  other.setCustomDataStorage(this.getCustomDataStorage());
  other.setErgebniseingang(this.getErgebniseingang());
  other.setErgebnis(this.getErgebnis());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(ErgebnisGueltigerEingang.class)){
        copyEntityAttributesUsingSetter((ErgebnisGueltigerEingang) other.castTo(ErgebnisGueltigerEingang.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von ErgebnisGueltigerEingang: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(ErgebnisGueltigerEingang other){
        other.setCustomDataXml(this.getCustomDataXml());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(ErgebnisGueltigerEingang other){
       }




    /**
    * Hat die Entität überhaupt einen CustomDataStorage?
    */
    private boolean isCustomDataSupported() {
      return getCustomDataStorage()!=null;
    }

    @Override
    public de.ivu.elect.jee.entity.customdata.CustomData getCustomData() {
      if (isCustomDataSupported()) {
        de.ivu.elect.jee.entity.customdata.CustomData result = getCustomDataStorage().getCustomData();
        result.setTechnicalEntity(this); // Fachliche Entität bei jedem Zugriff setzen
        return result;
      }
      return de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE;
    }


    @Override
    @SuppressWarnings("unchecked")
    public <T extends de.ivu.elect.jee.entity.customdata.CustomData> T getCustomData(Class<T> clazz) {
      if (isCustomDataSupported()) {
        return (T) getCustomData();
      }
      throw new IllegalStateException("Entität ErgebnisGueltigerEingang besitzt kein CustomDataStorage: "+this);
    }


    @Override
    public void updateCustomData() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().updateCustomData();
      }
    }


    public void clearCustomDataCache() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().clearCustomDataCache();
      }
    }

    @Override
    public String getCustomDataXml(){
      if (isCustomDataSupported()) {
        return getCustomDataStorage().getCustomDataXml();
      }
      return "";
    }

    @Override
    public void setCustomDataXml(String customDataXml){
      if (isCustomDataSupported()) {
        if (org.apache.commons.lang3.StringUtils.isBlank(customDataXml)) {
          if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
            throw new IllegalStateException("Entität ErgebnisGueltigerEingang hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
          }
          // ELECTMUC-2581
          System.err.println("Entität ErgebnisGueltigerEingang hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
        } else {
          getCustomDataStorage().setCustomDataXml(customDataXml);
        }
        clearCustomDataCache(); // WASDE-1131
      } else {
       if (org.apache.commons.lang3.StringUtils.isNotBlank(customDataXml)) {
         if (customDataXml.endsWith("EmptyCustomData/>")) {
            // Abwärtskompatibilität...alles gut, die alten, leeren CustomDataObjekte...
         } else {
           if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
             throw new IllegalStateException("Entität ErgebnisGueltigerEingang hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
           }
           // ELECT-5122
           System.err.println("Entität ErgebnisGueltigerEingang hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
         }
       }
      }
    }

    public boolean hasChangedCustomDataXml() {
      if (isCustomDataSupported()) {
        return getCustomDataStorage().hasChangedCustomDataXml();
      }
      return false;
    }


    @javax.persistence.Transient
    private transient ErgebnisGueltigerEingangTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public ErgebnisGueltigerEingangTK getErgebnisGueltigerEingangTK(){
    if (tkCache==null) {
    tkCache = new ErgebnisGueltigerEingangTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getErgebnisGueltigerEingangTK();
    }

  @Override
  public ErgebnisGueltigerEingangUK getUk(){
    return getErgebnisGueltigerEingangUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return ErgebnisGueltigerEingang.class;
  }

public ErgebnisGueltigerEingangUK getErgebnisGueltigerEingangUK(){

   return  new ErgebnisGueltigerEingangUK(



  );
}

  @javax.persistence.Transient
  private transient ErgebnisGueltigerEingangProperties properties;

  public ErgebnisGueltigerEingangProperties getProperties(){
    if (properties == null) {
      properties = new ErgebnisGueltigerEingangProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public ErgebnisGueltigerEingangProperties getErgebnisGueltigerEingangProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return ErgebnisGueltigerEingangConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return false;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
         }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
            return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
               }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "ERGEBNIS_GUELTIGER_EINGANG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "ErgebnisGueltigerEingang";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                            }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
